using System;
using System.Collections.Generic;
using System.IO;
using System.Text;

namespace Jade.DataMining.Classifier
{
    public class TuangouTextSource : IRawTextSource
    {
        private int currentIndex;
        private List<string> allLines;
        public TuangouTextSource(string textPath = @"E:\س\\BaiduCrawl\Code\HtmlTest\Jade.Util\Classifier\train.txt")
        {
            if (!File.Exists(textPath))
            {
                throw new Exception("ѵı");
            }
            allLines = new List<string>(File.ReadAllLines(textPath,Encoding.UTF8));
            this._isEnd = false;
            this.currentIndex = 0;
        }

        #region Implementation of IRawTextSource

        private bool _isEnd;

        public bool IsEnd
        {
            get { return _isEnd; }
        }

        public RawText GetNextRawText()
        {
            if (currentIndex >= 0 && currentIndex < this.allLines.Count)
            {
                var text = this.allLines[currentIndex];
                var sources = text.Split('\t');
                currentIndex++;
                if (currentIndex == this.allLines.Count)
                {
                    this._isEnd = true;
                }
                if (sources.Length == 2)
                {
                    return new RawText() { Category = sources[1], Text = sources[0] };
                }
                return null;
            }
            return null;
        }

        private List<RawText> _result;
        public List<RawText> GetAllRawText()
        {
            if (_result == null)
            {
                _result = new List<RawText>();
                System.Threading.Tasks.Parallel.For(0, allLines.Count, (i) =>
                {
                    var text = this.allLines[i];
                    var sources = text.Split('\t');
                    if (sources.Length == 2)
                    {
                        _result.Add(new RawText() {Category = sources[1], Text = sources[0]});
                    }
                });
            }
            return _result;
        }
        #endregion
    }
}