using System;
using System.Collections.Generic;
using System.IO;
using System.Text;

namespace Jade.DataMining.Classifier
{
    /// <summary>
    /// ĵתΪ
    /// </summary>
    public class Text2Matrix : ModelTraining
    {
        public Text2Matrix(bool loadFromFile = false)
        {
            this.IsTrain = loadFromFile;
            if (loadFromFile)
            {
                this.Load();
            }
        }

        private object global = new object();


        public Matrix CreateTrainMatrixUserParallel(IRawTextSource textSource)
        {
            var sources = textSource.GetAllRawText();
            var rows = new List<int>();
            rows.Add(0);
            var cols = new List<int>();
            var vals = new List<int>();
            var categories = new List<int>();
            // ̹ŷִ
            var segment = new PanguSegment();
            System.Threading.Tasks.Parallel.ForEach(sources, (rawText) =>
                                                                 {
                                                                     if (rawText != null)
                                                                     {
                                                                         int classId;
                                                                         lock (global)
                                                                         {
                                                                             // 
                                                                             if (
                                                                                 GlobalInfo.Instance.ClassToId.
                                                                                     ContainsKey(rawText.Category))
                                                                             {
                                                                                 classId =
                                                                                     GlobalInfo.Instance.ClassToId[
                                                                                         rawText.Category];
                                                                                 GlobalInfo.Instance.ClassToDocCount[
                                                                                     classId] += 1;
                                                                             }
                                                                             else
                                                                             {
                                                                                 classId =
                                                                                     GlobalInfo.Instance.ClassToId.Count;
                                                                                 GlobalInfo.Instance.ClassToId.Add(
                                                                                     rawText.Category, classId);
                                                                                 GlobalInfo.Instance.IdToClass.Add(
                                                                                     classId, rawText.Category);
                                                                                 GlobalInfo.Instance.ClassToDocCount.Add
                                                                                     (classId, 1);
                                                                             }
                                                                         }

                                                                         categories.Add(classId);

                                                                         var text = rawText.Text;

                                                                         //ִ
                                                                         var wordList = segment.DoSegment(text);

                                                                         // ȥͣô
                                                                         StopWordsHandler.RemoveStopWord(wordList);
                                                                         var partCols = new List<int>();
                                                                         var termFres = new Dictionary<int, int>();
                                                                         wordList.ForEach(word =>
                                                                         {
                                                                             int termId;
                                                                             lock (global)
                                                                             {

                                                                                 if (!GlobalInfo.Instance.TermToId. ContainsKey(word))
                                                                                 {
                                                                                     termId =
                                                                                         GlobalInfo.Instance.IdToTerm.
                                                                                             Count;
                                                                                     GlobalInfo.Instance.TermToId.Add(
                                                                                         word, termId);
                                                                                     GlobalInfo.Instance.IdToTerm.Add(
                                                                                         termId, word);
                                                                                 }
                                                                                 else
                                                                                 {
                                                                                     termId =
                                                                                         GlobalInfo.Instance.TermToId[
                                                                                             word];
                                                                                 }
                                                                                 // partCols ¼termId
                                                                                 if (!partCols.Contains(termId))
                                                                                 {
                                                                                     partCols.Add(termId);
                                                                                 }

                                                                                 //termFres ¼termidֵĴ
                                                                                 if (!termFres.ContainsKey(termId))
                                                                                 {
                                                                                     termFres[termId] = 1;
                                                                                 }
                                                                                 else
                                                                                 {
                                                                                     termFres[termId] += 1;
                                                                                 }
                                                                             }



                                                                         });

                                                                         partCols.Sort();
                                                                         partCols.ForEach(col =>
                                                                         {
                                                                             cols.Add(col);
                                                                             vals.Add(termFres[col]);
                                                                             lock (global)
                                                                             {
                                                                                 if (
                                                                                     !GlobalInfo.Instance.IdToDocCount.
                                                                                          ContainsKey(col))
                                                                                 {
                                                                                     GlobalInfo.Instance.IdToDocCount.
                                                                                         Add(col, 1);
                                                                                 }
                                                                                 else
                                                                                 {
                                                                                     GlobalInfo.Instance.IdToDocCount[
                                                                                         col] += 1;
                                                                                 }
                                                                             }
                                                                         });
                                                                         //fill rows rows¼ǰnӵĴĿ֮
                                                                         rows.Add(rows[rows.Count - 1] + partCols.Count);
                                                                     }
                                                                 });

            //fill GlobalInfo's idToIdf idf ĳһضIDFļĿ԰ô֮ļĿٽõȡõ

            foreach (var termId in GlobalInfo.Instance.TermToId.Values)
            {
                GlobalInfo.Instance.IdToIdf[termId] =
                    Math.Log(d: (rows.Count - 1) / (GlobalInfo.Instance.IdToDocCount[termId] + 1));
            }

            this.Save();

            this.IsTrain = true;

            return new Matrix(rows, cols, vals, categories);
        }

        public Matrix CreateTrainMatrix(IRawTextSource textSource)
        {
            var rows = new List<int>();
            rows.Add(0);
            var cols = new List<int>();
            var vals = new List<int>();
            var categories = new List<int>();
            // ̹ŷִ
            var segment = new PanguSegment();

            while (!textSource.IsEnd)
            {
                var rawText = textSource.GetNextRawText();

                if (rawText != null)
                {
                    int classId;

                    // 
                    if (GlobalInfo.Instance.ClassToId.ContainsKey(rawText.Category))
                    {
                        classId = GlobalInfo.Instance.ClassToId[rawText.Category];
                        GlobalInfo.Instance.ClassToDocCount[classId] += 1;
                    }
                    else
                    {
                        classId = GlobalInfo.Instance.ClassToId.Count;
                        GlobalInfo.Instance.ClassToId.Add(rawText.Category, classId);
                        GlobalInfo.Instance.IdToClass.Add(classId, rawText.Category);
                        GlobalInfo.Instance.ClassToDocCount.Add(classId, 1);
                    }

                    categories.Add(classId);

                    var text = rawText.Text;

                    //ִ
                    var wordList = segment.DoSegment(text);

                    // ȥͣô
                    StopWordsHandler.RemoveStopWord(wordList);
                    var partCols = new List<int>();
                    var termFres = new Dictionary<int, int>();
                    wordList.ForEach(word =>
                    {
                        int termId;
                        if (!GlobalInfo.Instance.TermToId.ContainsKey(word))
                        {
                            termId = GlobalInfo.Instance.IdToTerm.Count;
                            GlobalInfo.Instance.TermToId.Add(word, termId);
                            GlobalInfo.Instance.IdToTerm.Add(termId, word);
                        }
                        else
                        {
                            termId = GlobalInfo.Instance.TermToId[word];
                        }

                        // partCols ¼termId
                        if (!partCols.Contains(termId))
                        {
                            partCols.Add(termId);
                        }

                        //termFres ¼termidֵĴ
                        if (!termFres.ContainsKey(termId))
                        {
                            termFres[termId] = 1;
                        }
                        else
                        {
                            termFres[termId] += 1;
                        }

                    });

                    partCols.Sort();
                    partCols.ForEach(col =>
                    {
                        cols.Add(col);
                        vals.Add(termFres[col]);
                        if (!GlobalInfo.Instance.IdToDocCount.ContainsKey(col))
                        {
                            GlobalInfo.Instance.IdToDocCount.Add(col, 1);
                        }
                        else
                        {
                            GlobalInfo.Instance.IdToDocCount[col] += 1;
                        }
                    });
                    //fill rows rows¼ǰnӵĴĿ֮
                    rows.Add(rows[rows.Count - 1] + partCols.Count);
                }
            }


            //fill GlobalInfo's idToIdf idf ĳһضIDFļĿ԰ô֮ļĿٽõȡõ

            foreach (var termId in GlobalInfo.Instance.TermToId.Values)
            {
                GlobalInfo.Instance.IdToIdf[termId] =
                    Math.Log(d: (rows.Count - 1) / (GlobalInfo.Instance.IdToDocCount[termId] + 1));
            }

            this.Save();

            this.IsTrain = true;

            return new Matrix(rows, cols, vals, categories);
        }
        public Matrix CreateTrainMatrix(string path = @"E:\س\\BaiduCrawl\Code\HtmlTest\Jade.Util\Classifier\Sample")
        {
            var dirs = Directory.GetDirectories(path);
            var rows = new List<int>();
            rows.Add(0);
            var cols = new List<int>();
            var vals = new List<int>();
            var categories = new List<int>();
            foreach (var dir in dirs)
            {
                var directory = new DirectoryInfo(dir);
                int classId;
                if (GlobalInfo.Instance.ClassToId.ContainsKey(directory.Name))
                {
                    classId = GlobalInfo.Instance.ClassToId[directory.Name];
                }
                else
                {
                    classId = GlobalInfo.Instance.ClassToId.Count;
                    GlobalInfo.Instance.ClassToId.Add(directory.Name, classId);
                    GlobalInfo.Instance.IdToClass.Add(classId, directory.Name);
                }

                // ļ
                var classFiles = directory.GetFiles();

                GlobalInfo.Instance.ClassToDocCount.Add(classId, classFiles.Length);

                // ̹ŷִ
                var segment = new PanguSegment();

                // µļ
                classFiles.ForEach(file =>
                                       {
                                           Console.WriteLine(file.FullName);

                                           categories.Add(classId);

                                           var text = File.ReadAllText(file.FullName, Encoding.GetEncoding("gb2312"));

                                           //ִ
                                           var wordList = segment.DoSegment(text);

                                           // ȥͣô
                                           StopWordsHandler.RemoveStopWord(wordList);
                                           var partCols = new List<int>();
                                           var termFres = new Dictionary<int, int>();
                                           wordList.ForEach(word =>
                                                                {
                                                                    int termId;
                                                                    if (!GlobalInfo.Instance.TermToId.ContainsKey(word))
                                                                    {
                                                                        termId = GlobalInfo.Instance.IdToTerm.Count;
                                                                        GlobalInfo.Instance.TermToId.Add(word, termId);
                                                                        GlobalInfo.Instance.IdToTerm.Add(termId, word);
                                                                    }
                                                                    else
                                                                    {
                                                                        termId = GlobalInfo.Instance.TermToId[word];
                                                                    }

                                                                    // partCols ¼termId
                                                                    if (!partCols.Contains(termId))
                                                                    {
                                                                        partCols.Add(termId);
                                                                    }

                                                                    //termFres ¼termidֵĴ
                                                                    if (!termFres.ContainsKey(termId))
                                                                    {
                                                                        termFres[termId] = 1;
                                                                    }
                                                                    else
                                                                    { termFres[termId] += 1; }

                                                                });

                                           partCols.Sort();
                                           partCols.ForEach(col =>
                                                                {
                                                                    cols.Add(col);
                                                                    vals.Add(termFres[col]);
                                                                    if (!GlobalInfo.Instance.IdToDocCount.ContainsKey(col))
                                                                    {
                                                                        GlobalInfo.Instance.IdToDocCount.Add(col, 1);
                                                                    }
                                                                    else
                                                                    {
                                                                        GlobalInfo.Instance.IdToDocCount[col] += 1;
                                                                    }
                                                                });
                                           //fill rows rows¼ǰnӵĴĿ֮
                                           rows.Add(rows[rows.Count - 1] + partCols.Count);

                                       });
            }

            //fill GlobalInfo's idToIdf idf ĳһضIDFļĿ԰ô֮ļĿٽõȡõ

            foreach (var termId in GlobalInfo.Instance.TermToId.Values)
            {
                GlobalInfo.Instance.IdToIdf[termId] =
                    Math.Log(d: (rows.Count - 1) / (GlobalInfo.Instance.IdToDocCount[termId] + 1));
            }

            this.Save();

            this.IsTrain = true;

            return new Matrix(rows, cols, vals, categories);
        }

        public Matrix CreatePredictSample(string text)
        {
            if (!this.IsTrain)
            {
                throw new Exception("ѡѵģ");
            }

            // ̹ŷִ
            var segment = new PanguSegment();
            //ִ
            var wordList = segment.DoSegment(text);

            // ȥͣô
            StopWordsHandler.RemoveStopWord(wordList);
            var cols = new List<int>();
            var vals = new List<int>();
            var partCols = new List<int>();
            var termFres = new Dictionary<int, int>();
            wordList.ForEach(word =>
                                 {
                                     int termId;
                                     if (GlobalInfo.Instance.TermToId.ContainsKey(word))
                                     {
                                         termId = GlobalInfo.Instance.TermToId[word];

                                         if (!partCols.Contains(termId))
                                             partCols.Add(termId);

                                         //termFres ¼termidֵĴ
                                         if (!termFres.ContainsKey(termId))
                                         {
                                             termFres[termId] = 1;
                                         }
                                         else
                                         {
                                             termFres[termId] += 1;
                                         }
                                     }

                                 });

            partCols.Sort();
            partCols.ForEach(col =>
                                 {
                                     cols.Add(col);
                                     vals.Add(termFres[col]);
                                 });

            return new Matrix(null, cols, vals, null);
        }

        #region Overrides of ModelTraining

        public override void Load()
        {
            Console.WriteLine("ʼػϢ");
            GlobalInfo.Instance.Load();
        }

        public override void Save()
        {
            GlobalInfo.Instance.Save();
        }

        #endregion
    }
}